Debian Bug report logs - #619541
dpkg-source: internal error "Use of uninitialized value ..." (git)

version graph

Package: dpkg; Maintainer for dpkg is Dpkg Developers <debian-dpkg@lists.debian.org>; Source for dpkg is src:dpkg.

Reported by: Niels Thykier <niels@thykier.net>

Date: Thu, 24 Mar 2011 21:39:05 UTC

Severity: normal

Found in version 1.16.0~

Fixed in version dpkg/1.16.0

Done: Guillem Jover <guillem@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#619541; Package dpkg. (Thu, 24 Mar 2011 21:39:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Niels Thykier <niels@thykier.net>:
New Bug report received and forwarded. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 24 Mar 2011 21:39:08 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Niels Thykier <niels@thykier.net>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: dpkg-source: internal error "Use of uninitialized value ..." (git)
Date: Thu, 24 Mar 2011 22:35:30 +0100
Package: dpkg
Version: 1.16.0~
Severity: normal

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Hi

We got a report in Lintian that dpkg 1.16.0 causes test failures in
Lintian; so I checked out dpkg 1.16.0 (commit: 893a04ba) and I
noticed that one of the failures are caused by dpkg-source choking
on our "empty-diff" test (see the log).

~Niels

- -- System Information:
Debian Release: wheezy/sid
  APT prefers testing
  APT policy: (990, 'testing'), (500, 'unstable'), (1, 'experimental')
Architecture: i386 (i686)

Kernel: Linux 2.6.32-5-686 (SMP w/2 CPU cores)
Locale: LANG=en_DK.UTF-8, LC_CTYPE=en_DK.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages dpkg depends on:
ii  coreutils               8.5-1            GNU core utilities
ii  libbz2-1.0              1.0.5-6          high-quality block-sorting file co
ii  libc6                   2.11.2-11        Embedded GNU C Library: Shared lib
ii  libselinux1             2.0.96-1         SELinux runtime shared libraries
ii  xz-utils                5.0.0-2          XZ-format compression utilities
ii  zlib1g                  1:1.2.3.4.dfsg-3 compression library - runtime

dpkg recommends no packages.

Versions of packages dpkg suggests:
ii  apt                           0.8.11.5   Advanced front-end for dpkg

- -- no debconf information

*** dpkg-error.log
.... running tests ....
rm -rf debian/tests
mkdir debian/tests
private/runtests  cruft-empty-diff
Package tests:
Running cruft-empty-diff 1.0-1...
building...
testing...
Running cruft-empty-diff 1.0-1... building... testing... FAILED:
- --- t/tests/cruft-empty-diff/tags	2011-01-27 13:31:45.751999999 +0000
+++ debian/tests/cruft-empty-diff/tags.cruft-empty-diff	2011-03-24 21:31:32.584001191 +0000
@@ -1 +1,7 @@
- -W: cruft-empty-diff source: empty-debian-diff
+Use of uninitialized value $file in -e at /usr/share/perl5/Dpkg/Source/Functions.pm line 77.
+Use of uninitialized value $file in open at /usr/share/perl5/Dpkg/Source/Functions.pm line 78.
+dpkg-source: error: cannot write %s: No such file or directory
+internal error: dpkg-source -x failed with status 
+internal error: 2
+warning: collect info unpacked about package cruft-empty-diff failed
+warning: skipping check of source package cruft-empty-diff
make: *** [runtests] Error 1

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iQIcBAEBCAAGBQJNi7keAAoJEAVLu599gGRCMqcQAKyJHprvVhTzXv8l9UjLjoZg
xQv8NS5cpjejnV2+pbqZxdCyiGzFDBdmcxczeLzE1j2XmtJK/n1lZhlrGHyxuyRa
XnY6u1PsIKwE3dAKlY8uxasKgzvkusuyU+pKZZ4O4bQnXUTCnqePwi4gegen7DN0
+XZhZO0aEznrDETP/xi1GDWTo3yKNTs07o5Bif7lYbpvlODi8FXrcs1f7mfhBNgC
5YB4CKxZYttew1W0G7JGs01a9L+PJwzjyVOG4IoFQddZuLF60v9osNGkq/Nx0NZZ
1cDvmChNSDh39eVNxfGIu26AUl0amZeaG86Hd6urR/7xDTbgRyLJKEWl7kAfX1+X
VCWKAvE5xwVvYc5o8pH0ibi4T92BdsLhyeDjXbrQvJxgYgQayDkNUwZHyaL+7EvH
yWN+qUiop+7NOF/RUyXZxzuAOoP+vdT1fCYfQrnemIBQO7vO5JYSd3qofJFGX5O3
g6Md4xxnErqUW4d1gCWwS2QAzkfDI+ogBPOMRoCbBkMqn0dCq6EXgAFCWVM9lPLR
G+BUMEtRauKT1YIR5pInAGO1/Yx0y2U3nOa3oj94kidwbPPP2Y0HYnMGGcpIIbZs
w+m6N914ZuNRn+0CWoT70S1GnCtISndOMXuQ8/IGgH9mnnJWnAQpQkhld2HU4gpT
k8/9TTX1LVheTc75QGXi
=+CY5
-----END PGP SIGNATURE-----




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#619541; Package dpkg. (Thu, 24 Mar 2011 22:57:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Thu, 24 Mar 2011 22:57:09 GMT) Full text and rfc822 format available.

Message #10 received at 619541@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Niels Thykier <niels@thykier.net>, 619541@bugs.debian.org
Subject: Re: Bug#619541: dpkg-source: internal error "Use of uninitialized value ..." (git)
Date: Thu, 24 Mar 2011 23:55:06 +0100
Hello,

On Thu, 24 Mar 2011, Niels Thykier wrote:
> We got a report in Lintian that dpkg 1.16.0 causes test failures in
> Lintian; so I checked out dpkg 1.16.0 (commit: 893a04ba) and I
> noticed that one of the failures are caused by dpkg-source choking
> on our "empty-diff" test (see the log).

Thanks for the report, fixed in the git repo.

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Follow my Debian News ▶ http://RaphaelHertzog.com (English)
                      ▶ http://RaphaelHertzog.fr (Français)




Added tag(s) pending. Request was from Raphaël Hertzog <hertzog@debian.org> to control@bugs.debian.org. (Thu, 24 Mar 2011 22:57:11 GMT) Full text and rfc822 format available.

Message sent on to Niels Thykier <niels@thykier.net>:
Bug#619541. (Thu, 24 Mar 2011 22:57:17 GMT) Full text and rfc822 format available.

Message #15 received at 619541-submitter@bugs.debian.org (full text, mbox):

From: Raphaël Hertzog <hertzog@debian.org>
To: 619541-submitter@bugs.debian.org
Subject: Bug#619541 marked as pending
Date: Thu, 24 Mar 2011 22:54:21 +0000
tag 619541 pending
thanks

Hello,

Bug #619541 reported by you has been fixed in the Git repository. You can
see the changelog below, and you can check the diff of the fix at:

    http://git.debian.org/?p=dpkg/dpkg.git;a=commitdiff;h=7ea2064

---
commit 7ea2064c46b77398a63d7f7a543ebcf08f7c74d2
Author: Raphaël Hertzog <hertzog@debian.org>
Date:   Thu Mar 24 23:53:37 2011 +0100

    Dpkg::Source::Patch: don't choke on empty patches
    
    Commit 255e73e11d1365fbb1e8d78287fad751a8ebc6e5 introduced a regression
    with empty patches by assuming that a patch analysis would always give
    back at least one filename.
    
    Reported-by: Niels Thykier <niels@thykier.net>

diff --git a/debian/changelog b/debian/changelog
index c3707b2..41772cb 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -100,6 +100,8 @@ dpkg (1.16.0) UNRELEASED; urgency=low
     in Uploaders. Closes: #598922
   * Ignore whitespaces after options in headers of changelog entries.
     Closes: #605719
+  * Fix dpkg-source's regression with empty patches (introduced while fixing
+    #613023). Closes: #619541
 
   [ Jonathan Nieder ]
   * Remove support for use of synchronous sync(2), due to its pernicious




Reply sent to Guillem Jover <guillem@debian.org>:
You have taken responsibility. (Sat, 02 Apr 2011 04:21:51 GMT) Full text and rfc822 format available.

Notification sent to Niels Thykier <niels@thykier.net>:
Bug acknowledged by developer. (Sat, 02 Apr 2011 04:21:51 GMT) Full text and rfc822 format available.

Message #20 received at 619541-close@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 619541-close@bugs.debian.org
Subject: Bug#619541: fixed in dpkg 1.16.0
Date: Sat, 02 Apr 2011 04:17:20 +0000
Source: dpkg
Source-Version: 1.16.0

We believe that the bug you reported is fixed in the latest version of
dpkg, which is due to be installed in the Debian FTP archive:

dpkg-dev_1.16.0_all.deb
  to main/d/dpkg/dpkg-dev_1.16.0_all.deb
dpkg_1.16.0.dsc
  to main/d/dpkg/dpkg_1.16.0.dsc
dpkg_1.16.0.tar.bz2
  to main/d/dpkg/dpkg_1.16.0.tar.bz2
dpkg_1.16.0_amd64.deb
  to main/d/dpkg/dpkg_1.16.0_amd64.deb
dselect_1.16.0_amd64.deb
  to main/d/dpkg/dselect_1.16.0_amd64.deb
libdpkg-dev_1.16.0_amd64.deb
  to main/d/dpkg/libdpkg-dev_1.16.0_amd64.deb
libdpkg-perl_1.16.0_all.deb
  to main/d/dpkg/libdpkg-perl_1.16.0_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 619541@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Guillem Jover <guillem@debian.org> (supplier of updated dpkg package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Fri, 01 Apr 2011 23:56:54 +0200
Source: dpkg
Binary: libdpkg-dev dpkg dpkg-dev libdpkg-perl dselect
Architecture: source amd64 all
Version: 1.16.0
Distribution: unstable
Urgency: low
Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Changed-By: Guillem Jover <guillem@debian.org>
Description: 
 dpkg       - Debian package management system
 dpkg-dev   - Debian package development tools
 dselect    - Debian package management front-end
 libdpkg-dev - Debian package management static library
 libdpkg-perl - Dpkg perl modules
Closes: 31141 97076 397121 476335 483119 591858 594179 596841 598922 600854 604914 605719 606080 608829 611741 612203 612465 612472 613023 616096 616502 617923 619311 619541 620380
Changes: 
 dpkg (1.16.0) unstable; urgency=low
 .
   [ Guillem Jover ]
   * Use DPKG_MAINTSCRIPT_PACKAGE environment variable as package name on
     dpkg-divert when no --package or --local options have been specified.
   * Do not allow versions starting with non-digit when doing strict parsing,
     warn otherwise.
   * Update dpkg(1) to note that --status-fd output does not contain newlines
     in error messages anymore (this was fixed in 1.15.0).
   * Add a new --status-logger option to dpkg, similar to --status-fd but
     instead invoke the command ourselves and feed the status information
     to its standard input. Suggested by Raphaël Hertzog.
   * Add missing space in update-alternative --set-selections output.
   * Add missing options to update-alternative --help output.
   * Count “conffile name is duplicated” for dpkg-deb warning count summary.
   * Improve and clarify strings for translation. Closes: #604914
   * Prefix all fatal error messages with “error: ”.
   * Do not check presence of update-rc.d in the PATH in dpkg, as it's not
     a program needed for dpkg correct operation.
   * Fix dpkg -GEO options on multiple versions of the same packages.
     Closes: #31141
   * Propagate --admindir to programs run from maintainer scritpts.
     Closes: #97076
   * Do not fail when trying to remove the root directory. This will only
     happen either on distributions where dpkg is a foreign package manager,
     or on artificial dpkg databases.
   * Always warn when parsing any package control data which does not have
     an Architecture field except for status and status log files when
     packages are not-installed or half-installed.
   * By default reject installing packages w/o an Architecture field. They
     now need --force-architecture, dpkg will still warn about them though.
   * Fix build failure when passing --disable-nls to configure.
   * Do not segfault on “dpkg -i --no-act”.
   * Add missing semicolon to the vsnprintf() compat declaration.
     Thanks to Robert Millan. Closes: #612203
   * On install for Ubuntu adjust the i386 GNU cpu name in cputable.
     Thanks to Colin Watson <cjwatson@ubuntu.com>. Closes: #611741
   * Sync the info database directory on unpack instead of the temporary
     control information directory, and print the correct pathname on error
     instead of the last file acted on that directory.
   * Document in dpkg-query --help output and man page that --list and --show
     arguments are optional.
   * Do not read and write the available file unnecessarily.
     Thanks to Michel Lespinasse <walken@zoy.org>. Closes: #397121
   * Fix typo in «dpkg-name --overwrite» argument parsing so that it actually
     works at all. Thanks to Ivan Gagis <igagis@gmail.com>. LP: #728708
   * Add armhf support to ostable and triplettable. Closes: #594179
   * Set the modification time for unpacked symlinks on supported systems.
   * Fix undefined value useage in dpkg-genchanges when adding files w/o a
     matching architecture, because they are not present in debian/control,
     this is most commonly the case due to dpkg-distaddfile.
   * Terminate immediately on dpkg-divert rename errors instead of propagating
     up the error codes, this improves error reporting and avoids triggering
     leak detectors. Closes: #620380
   * When moving a diverted file across filesystems in dpkg-divert, remove
     the source file.
 .
   [ Raphaël Hertzog ]
   * Fail properly when debian/source/format is empty. Closes: #600854
   * Add new deb-src-control(5) manual page documenting the debian/control
     file contained in source packages.
     - it documents the X[SBC]- prefix. Closes: #476335
     - it documents the VCS-* fields too. Closes: #483119
     Thanks to Oxan van Leeuwen <oxan@oxanvanleeuwen.nl> who wrote it
     as part of the Google Code In program.
   * Enhance dpkg-shlibdeps to not fail immediatly when a library is not found.
     Instead continue and fail after all problems have been reported. Thanks
     to Chris Baines <cbaines8@gmail.com> for the patch. Closes: #596841
   * Fix dpkg-source to not list Debian packaging files as modified
     upstream files in Format "1.0" when unpacking to a non-standard
     directory.
   * Apply patch from Colin Watson to let dpkg-buildflags return -O3
     instead of -O2 when building ppc64 packages on Ubuntu. Closes: #612472
   * Add new function get_control_path() to Dpkg::Path, it wraps dpkg-query
     --control-path.
   * Update dpkg-shlibdeps to be multiarch-ready:
     - use get_control_path() to find symbols/shlibs files
     - parse correctly the output of dpkg --search
   * Small fix to support files >2GB in .deb on 64-bit systems. Closes: #616502
     Thanks to Martin Dorey <mdorey@bluearc.com> for the patch.
   * dpkg-source now keeps the file ordering in the autogenerated patch when
     regenerating it. Closes: #606080
     Thanks to Colin Watson for the patch.
   * dpkg-source now uses a timestamp retrieved from the filesystem when
     resetting the timestamp of patched files so that a time skew when using
     NFS doesn't introduce any inconsistency. Closes: #613023
     Thanks to Jonathan Nieder <jrnieder@gmail.com> for the patch and the
     diagnosis.
   * dpkg-source will now remove quilt's .pc directory when --unapply-patches
     is in use. Closes: #591858
   * dpkg-source is now a bit less strict when parsing patches:
     - it accepts seeing the same file twice; Closes: #608829
     - it doesn't match on the English text "No newline at end of file" as it
       might be translated in some cases. Closes: #612465
   * Improve parser in Dpkg::Control::Hash to not require an empty line
     before the PGP signature. Closes: #617923
     Thanks to Roger Leigh for the initial patch.
   * Fix a regression in dpkg-divert where using --rename led to a failure when
     the rename implies crossing file systems. Thanks to Durk Strooisma for
     spotting it.
   * Use the correct mtime when installing a file with statoverrides.
     Regression introduced in 1.16.0. LP: #739179
   * Remove duplicate word in german translation of dpkg(1). Closes: #616096
   * Strip repeated non-significant spaces before and after newlines
     in Uploaders. Closes: #598922
   * Ignore whitespaces after options in headers of changelog entries.
     Closes: #605719
   * Fix dpkg-source's regression with empty patches (introduced while fixing
     #613023). Closes: #619541
 .
   [ Jonathan Nieder ]
   * Remove support for use of synchronous sync(2), due to its pernicious
     side-effects and to ease maintenance.
   * Clarify that an up-to-date dpkg only needs to be unpacked for
     dpkg-maintscript-helper to work.
 .
   [ Steve Langasek ]
   * Add new variables to dpkg-architecture, DEB_HOST_MULTIARCH and
     DEB_BUILD_MULTIARCH, that return the "ideal" GNU triplet for each
     architecture which should be used as the path component for library
     installation.
 .
   [ Mark Hymers ]
   * Add support for Built-Using field. Closes: #619311
 .
   [ Updated programs translations ]
   * German (Sven Joachim).
   * Portuguese (Miguel Figueiredo).
   * Spanish (Javier Fernandez-Sanguino).
   * Swedish (Peter Krefting).
 .
   [ Updated man page translations ]
   * German (Helge Kreutzmann).
   * Swedish (Peter Krefting).
 .
   [ Updated scripts translations ]
   * German (Helge Kreutzmann).
   * Swedish (Peter Krefting).
 .
   [ Updated dselect translations ]
   * Spanish (Javier Fernandez-Sanguino).
Checksums-Sha1: 
 ce2157f0050ae5307c0b3f867219e90eccea417f 1200 dpkg_1.16.0.dsc
 c5588cfa254ff0d698fc1eb7d9d11be9da235371 5321098 dpkg_1.16.0.tar.bz2
 68d767846ee0bd9a20d627ef3371c2c98c12e066 494608 libdpkg-dev_1.16.0_amd64.deb
 239a3d17163706530443fb847bb61703ac6e0c00 2230440 dpkg_1.16.0_amd64.deb
 59ad8d6ca4573c2bb85861472c9437ed23a0e77c 948708 dselect_1.16.0_amd64.deb
 64c9a96eb3caaf34d1d14f09c5c81c4826539da6 870310 dpkg-dev_1.16.0_all.deb
 24c2b86c3cb1867ae4ddf1e3c1a631ca73b8fe0d 746970 libdpkg-perl_1.16.0_all.deb
Checksums-Sha256: 
 dc45d4c80599fb4fb377caf497c003ef5fef8e1fcf0b0cba51bae457041c2554 1200 dpkg_1.16.0.dsc
 2536bd1493ba5de8d0914c30d6b83d4390013caa98580bd33a735cebe445004a 5321098 dpkg_1.16.0.tar.bz2
 1e1e7e02834b554932aa0b7ef48b3b2e982893011f7261629f19882a0271a1b3 494608 libdpkg-dev_1.16.0_amd64.deb
 0f7858e704d1e0dd8f7195921cb29d6e296ff71e4568cf6a99c9a89a62907670 2230440 dpkg_1.16.0_amd64.deb
 e068fa295a74e769407ab9230208a20c3385c9f978d130077a0a5b506e66e14b 948708 dselect_1.16.0_amd64.deb
 54603f6285f06b8f805394ed63c63aad3671e66c9385818361a89190ced55972 870310 dpkg-dev_1.16.0_all.deb
 10aa393491951ac72f6d8429974e7be5c62b52fbb10fe8437fceb274ce8a2b1c 746970 libdpkg-perl_1.16.0_all.deb
Files: 
 8aaddcf28fe29848e0839e4f49aa5b27 1200 admin required dpkg_1.16.0.dsc
 dc83fe7c1346a2a7bf78548306447c1d 5321098 admin required dpkg_1.16.0.tar.bz2
 700983a5d39442c66f07403f13afc3bb 494608 libdevel optional libdpkg-dev_1.16.0_amd64.deb
 7a243ebcc1618a0b7a1054c510459191 2230440 admin required dpkg_1.16.0_amd64.deb
 433d60711295f8c311c85a9d31020ac1 948708 admin optional dselect_1.16.0_amd64.deb
 6a049c453a6370cab4e0a8611ed0153e 870310 utils optional dpkg-dev_1.16.0_all.deb
 86124110a1596fddc34fff8fc29a15e8 746970 perl optional libdpkg-perl_1.16.0_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iEYEARECAAYFAk2WnHUACgkQuW9ciZ2SjJvVoQCdEWDb2Bi1NhycZk3sZ1Ak7ARE
kR4AoPHbIFD2mzngex1DGcFIKQ1CRXaH
=QKGg
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sat, 30 Apr 2011 08:10:11 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 04:32:39 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.